Dim dlgHandle,floderSource,floderOutput,curDlg,NeedConvert,fso,schDoc(),schSuffix,asciiSuffix,ascii,failMessage(),checkAll,LogFlag,successFile(),outMessageName
Sub Main
	NeedConvert = False
	ascii = "ascii"
	floderSource = ActiveDocument.Path
	floderOutput = floderSource & "\" & ascii
	checkAll = False
	LogFlag=2
	Setting
	Dim sonfile
	sonfile = floderSource & "\" & ascii
	If sonfile <> floderOutput Then
		checkAll = True
	End If
	If NeedConvert = True Then
		outMessageName = floderOutput & "\convertLog.txt"
		schSuffix = "sch"
		asciiSuffix = ".txt"
		ReDim schDoc(2,0)
		ReDim failMessage(0)
		ReDim successFile(0)
		Set fso = CreateObject("Scripting.FileSystemObject")
		checkDirPath(floderSource)
		checkDirPath(floderOutput)
		getAllConvertFiles(floderSource)
		Dim index
		index = UBound(schDoc,2)-1
		For i = 0 To index
			convertSch(floderSource,floderOutput,schDoc(0,i),schDoc(1,i),schDoc(2,i))
		Next
		index = UBound(successFile)
		successFile(0) = "Convert Success:" & index
		logMessageArray(successFile)
		index = UBound(failMessage)
		failMessage(0) = "Convert fail:" & index
		logMessageArray(failMessage)
		MsgBox "Finish" & Chr(10) & outMessageName
		Set fso = Nothing	
	End If
	
End Sub
Sub Setting
	Begin Dialog UserDialog 540,196,"Pads Convert Setting",.dlgfunc ' %GRID:10,7,1,1
		GroupBox 20,21,480,42,"pads source",.GroupBox1
		GroupBox 20,77,480,42,"pads output",.GroupBox2
		PushButton 400,32,80,21,"B&rower...",.BrowerBtnSource
		PushButton 400,91,80,21,"B&rower...",.BrowerBtnOut
		Text 40,35,350,14,"Text1",.floderSource
		Text 40,95,350,14,"Text1",.floderOutput
		PushButton 300,160,90,21,"Convert",.convertBtn
		CancelButton 410,161,90,21,.cancelBtn
	End Dialog
	Dim dlg As UserDialog
	Dim n
	While True
		curDlg = "1"
		n = Dialog(dlg,l)
		If n = 0 Then Abort
		If n=3 Then 
			NeedConvert = True
			Exit Sub
		End If
	Wend	
End Sub


Rem See DialogFunc help topic for more information.
Private Function dlgfunc(DlgItem$, Action%, SuppValue&) As Boolean
	Dim s
	Select Case Action%
	Case 1 ' Dialog box initialization
		If SuppValue <> 0 Then
			dlgHandle = SuppValue
		End If
		If curDlg = "1" Then
			DlgText "floderSource", floderSource
			DlgText "floderOutput", floderOutput
		End If
		
	Case 2 ' Value changing or button pressed
		Rem dlgfunc = True ' Prevent button press from closing the dialog box
		If DlgItem$ = "BrowerBtnSource" Then
			s = BrowseDirectory
			If s <> "" Then
				DlgText "floderSource", s
				floderSource = DlgText("floderSource")
				floderOutput = floderSource & "\" & ascii
				DlgText "floderOutput", floderOutput
			End If
			dlgfunc = True
		End If
		If DlgItem$ = "BrowerBtnOut" Then
			s = BrowseDirectory
			If s <> "" Then
				DlgText "floderOutput", s
				floderOutput = DlgText("floderOutput")
			End If
			dlgfunc = True
		End If
	Case 3 ' TextBox or ComboBox text changed
	Case 4 ' Focus changed
	Case 5 ' Idle
		Rem dlgfunc = True ' Continue getting idle actions
	Case 6 ' Function key
	End Select
End Function
Function addFail(failPath As String)
	Dim index
	index = UBound(failMessage)
	ReDim Preserve failMessage(index+1)
	failMessage(index+1) = failPath
End Function
Function addSuccess(filePath As String)
	Dim index
	index = UBound(successFile)
	ReDim Preserve successFile(index+1)
	successFile(index+1) = filePath
End Function
Function logMessageArray(message)
	Dim logFile
	Set logFile = fso.OpenTextFile(outMessageName,LogFlag,True)
	Dim index
	index = UBound(message)
	For i=0 To index
		logFile.write(message(i))
		logFile.write(Chr(10))
	Next
   	Set logFile = Nothing
    If LogFlag=2 Then
        LogFlag = 8
    End If
    Set logFile = Nothing
End Function
Function convertSch(source As String,out As String,file_path As String,file_name As String,file_suffix As String)
	On Error Resume Next
	Dim full_path,doc,outPath
	full_path = source & file_path & file_name & file_suffix
	outPath = out & file_path & file_name & asciiSuffix
	checkDirPath(out & file_path)
	Set doc = OpenTempDocument(full_path)
	doc.ExportASCII(outPath,ppcbASCIISectionAll)
	If fso.FileExists(outPath) = False Then
		addFail(full_path)
	Else 
		addSuccess(full_path)
	End If
	If Err.Number <> 0 Then
		addFail(full_path)
	End If
End Function
Function createDir(path As String)
	If fso.FolderExists(path) <> True Then 
	   fso.CreateFolder(path)
    End If
End Function
Function checkDirPath(NeedPath As String)
	Dim Match,Matches,rex,Path,Index
	Index = 0
	Set rex = CreateObject("VBScript.regExp")
	rex.Pattern = "\\([^\\]+)"
	rex.Global = True
	Set Matches = rex.Execute(NeedPath)
	For Each Match In Matches
		If Index = 0 Then
			Index = Match.FirstIndex
			Path = Mid(NeedPath,1,Index)
		End If
		Path = Path & Match.Value
		createDir(Path)
	Next
	Set rex = Nothing
	Set Matches = Nothing
End Function
Function getAllConvertFiles(source As String)
	If fso.FolderExists(source) Then
		saveFolderFile(source,"\",checkAll)
	End If
End Function
Function saveFolderFile(path As String,relative_path As String,checkAscii) 
	Dim floder,file
	Set floder = fso.GetFolder(path)
	For Each file In floder.Files
		Dim fileName
		fileName = file.Name
		saveFile(relative_path,fileName)
	Next
	For Each subfloder In floder.SubFolders
		Dim folderName
		folderName = subfloder.Name
		If checkAscii=True Or floderName <> ascii Then
			saveFolderFile(path & "\" & folderName,relative_path & folderName & "\",True)
		End If
	Next
	Set floder = Nothing
End Function
Function saveFile(relative_path As String,fileName As String)
	Dim rex,index,lowFileName
	Set rex = CreateObject("VBScript.regExp")
	rex.Global = True
	rex.Pattern = "\." & schSuffix & "$"
	lowFileName = LCase(fileName)
	If rex.test(lowFileName) Then
		index = UBound(schDoc,2)
		ReDim Preserve schDoc(2,index+1)
		Dim Name 
		Name= rex.replace(lowFileName,"")
		Dim NameLen
		NameLen = Len(Name)
		Name = Mid(fileName,1,NameLen)
		Dim suffix
		suffix = Mid(fileName,NameLen+1)
		schDoc(0,index) = relative_path
		schDoc(1,index) = Name
		schDoc(2,index) = suffix
	End If 
	Set rex = Nothing
End Function
Type BROWSEINFO
    hwndOwner As Long 
    pidlRoot As Long
    pszDisplayName As Long 
    lpszTitle As Long 
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type
Private Declare Function SHBrowseForFolder Lib "shell32.dll" (ByRef bi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal dirName As String) As Long
Function BrowseDirectory As String
	Dim bi As BROWSEINFO, s As String*256, pos
	bi.ulFlags = 9
	bi.hwndOwner = dlgHandle
	Dim pidl As Long
	pidl = SHBrowseForFolder(bi)
	If pidl <> 0 Then
		If SHGetPathFromIDList(pidl, s) <> 0 Then
			pos = InStr(s, Chr(0))
			BrowseDirectory = Left(s, pos-1)
		End If
	End If
End Function
Sub Abort
	End
End Sub
